/* --------------------------------------
   Tabling instructions: Auxiliary Macros
   -------------------------------------- */

#define store_new_subgoal(PTR, ARITY, AP, SG_FR, BOTTOM_SG_NODE)            \
        { register CELL *pt_args;                                           \
          register gen_cp_ptr gcp;                                          \
                                                                            \
          /* store args */                                                  \
          pt_args = XREGS + (ARITY);                                        \
	  while (pt_args > XREGS) {                                         \
            register CELL aux_arg = pt_args[0];                             \
            --PTR;                                                          \
            --pt_args;                                                      \
            *PTR = aux_arg;                                                 \
	  }                                                                 \
          /* initialize generator choice point pointer */                   \
          gcp = --GEN_CP(PTR);                                              \
          /* store subgoal frame and adjust top subgoal frame pointer */    \
          new_subgoal_frame(SG_FR, BOTTOM_SG_NODE, gcp, LOCAL_top_sg_fr);   \
          LOCAL_top_sg_fr = SG_FR;                                          \
          /* store generator choice point */                                \
          HBREG = H;                                                        \
          gcp->gcp_tr = TR;            	                                    \
          gcp->gcp_ap = (yamop *)(AP);                                      \
          gcp->gcp_h  = H;                                                  \
          gcp->gcp_b  = B;                                                  \
          gcp->gcp_env = ENV;                                               \
          gcp->gcp_cp = CPREG;                                              \
          gcp->gcp_sg_fr = SG_FR;                                           \
          set_cut((CELL *)gcp, B);                                          \
          B = NORM_CP(gcp);                                                 \
          YAPOR_SET_LOAD(B);                                                \
        }


#define restore_generator_node(PTR, ARITY, AP)          \
        { register CELL *pt_args, *x_args;              \
          register gen_cp_ptr gcp = (gen_cp_ptr)PTR;    \
                                                        \
          /* restore generator choice point */          \
          H = HBREG = PROTECT_FROZEN_H(NORM_CP(gcp));   \
          CPREG = gcp->gcp_cp;                          \
          ENV = gcp->gcp_env;                           \
          YAPOR_update_alternative(PREG, (yamop *) AP)  \
          gcp->gcp_ap = (yamop *) AP;                   \
          /* restore args */                            \
          pt_args = (CELL *)(gcp + 1) + ARITY;          \
          x_args = XREGS + 1 + ARITY;                   \
          while (x_args > XREGS + 1) {                  \
            register CELL x = pt_args[-1];              \
            --x_args;                                   \
            --pt_args;                                  \
            *x_args = x;                                \
	  }                                             \
        }


#define store_consumer_node(PTR, SG_FR)                                               \
        { register cons_cp_ptr ccp;                                                   \
          register dep_fr_ptr new_dep_fr;                                             \
          register choiceptr leader_cp;                                               \
                                                                                      \
          /* find leader node */                                                      \
          direct_dependency(SG_FR, leader_cp);                                        \
          new_dep_fr = LOCAL_top_dep_fr;                                              \
          while (leader_cp > NORM_CP(DepFr_cons_cp(new_dep_fr))) {                    \
            if (leader_cp <= DepFr_leader_cp(new_dep_fr)) {                           \
              leader_cp = DepFr_leader_cp(new_dep_fr);                                \
              break;                                                                  \
            }                                                                         \
            new_dep_fr = DepFr_next(new_dep_fr);                                      \
          }                                                                           \
	  /* initialize ccp */                                                        \
          ccp = --CONS_CP(PTR);                                                       \
          /* adjust freeze registers */                                               \
          H_FZ = H;                                                                   \
          B_FZ = NORM_CP(ccp);                 	                                      \
          TR_FZ = TR;                                                                 \
          /* store dependency frame and adjust top dependency frame pointer */        \
          new_dependency_frame(new_dep_fr, ccp, leader_cp, SG_FR, LOCAL_top_dep_fr);  \
          LOCAL_top_dep_fr = new_dep_fr;                                              \
          /* store consumer choice point */                                           \
          HBREG = H;                                                                  \
          ccp->ccp_tr = TR;         	                                              \
          ccp->ccp_ap = ANSWER_RETURN;                                                \
          ccp->ccp_h  = H;                                                            \
          ccp->ccp_b  = B;                                                            \
          ccp->ccp_env= ENV;                                                          \
          ccp->ccp_cp = CP;                                                           \
          ccp->ccp_dep_fr = LOCAL_top_dep_fr;                                         \
          set_cut(((CELL *)ccp), B);                                                  \
          B = NORM_CP(ccp);                                                           \
          YAPOR_SET_LOAD(B);                                                          \
        }


#define allocate_environment(PTR)  \
        PTR[E_CP] = (CELL) CP;     \
        PTR[E_E] = (CELL) ENV;     \
        PTR[E_B] = (CELL) B;       \
        ENV = PTR


/* --------------------
   Tabling instructions   
   -------------------- */  

/* ***** printing arguments *****
    { 
      int i, arity;
      arity = PREG->u.ld.s;
      for (i = 1; i <= arity; i++) {
        if (i > 1) printf(", ");
        plwrite(XREGS[i], print_char, 4);
      }
    }

* put in absmi *
static int print_char(int ch) {
  printf("%c",ch);
  return ch;
}
*/
  PBOp(table_try_me_single, ld)
    sg_node_ptr sg_node;
    sg_fr_ptr sg_fr;
    CELL *Yaddr = Y;
    check_trail();
    sg_node = subgoal_search(PREG->u.ld.s, TabEnt_subgoal_trie(PREG->u.ld.te), &Yaddr);
    Y = Yaddr;
    /* the child field of the returned node points to the subgoal frame */
    LOCK(TrNode_lock(sg_node));
    if (TrNode_child(sg_node) == NULL) {
      /* new subgoal */
      store_new_subgoal(Y, PREG->u.ld.s, COMPLETION, sg_fr, sg_node);
      optyap_message_type2("table_try_single --> new subgoal (sg_fr %x)", 
                           (unsigned int)sg_fr);
      TrNode_child(sg_node) = (sg_node_ptr)sg_fr;
      UNLOCK(TrNode_lock(sg_node));
      PREG = NEXTOP(PREG, ld);
      PREFETCH_OP(PREG);
      allocate_environment(Y);
      GONext();
    }
    /* subgoal not new */
    UNLOCK(TrNode_lock(sg_node));
    sg_fr = (sg_fr_ptr) TrNode_child(sg_node);
    if (SgFr_completed(sg_fr)) {
      /* subgoal completed */
      ans_node_ptr ans_node = SgFr_answer_trie(sg_fr);
      optyap_message_type2("table_try_single --> subgoal completed (sg_fr %x)",
                           (unsigned int)sg_fr);
      if (IS_ANSWER_LEAF_NODE(ans_node)) {
        /* yes answer --> procceed */
        PREG = (yamop *)CP;
        PREFETCH_OP(PREG);
        Y = ENV;
        GONext();
      } else if (TrNode_child(ans_node) == NULL) {
        /* no answers --> fail */
        goto fail;
      }
      /* load answers */
      *--Y = 0;  /* vars_arity */
      *--Y = 0;  /* heap_arity */
      PREG = (yamop *) TrNode_child(ans_node);
      PREFETCH_OP(PREG);
      GONext();
    }
    /* subgoal not completed */
    optyap_message_type2("table_try_single --> subgoal not completed (sg_fr %x)",
                         (unsigned int)sg_fr);
    store_consumer_node(Y, sg_fr);
    /* execute the table_answer_return instruction */
    goto answer_return;
  ENDPBOp();



  PBOp(table_try_me, ld)
    sg_node_ptr sg_node;
    sg_fr_ptr sg_fr;
    CELL *Yaddr = Y;
    check_trail();
    sg_node = subgoal_search(PREG->u.ld.s, TabEnt_subgoal_trie(PREG->u.ld.te), &Yaddr);
    Y = Yaddr;
    /* the child field of the returned node points to the subgoal frame */
    LOCK(TrNode_lock(sg_node));
    if (TrNode_child(sg_node) == NULL) {
      /* new subgoal */
      store_new_subgoal(Y, PREG->u.ld.s, PREG->u.ld.d, sg_fr, sg_node);
      optyap_message_type2("table_try --> new subgoal (sg_fr %x)", 
                           (unsigned int)sg_fr);
      TrNode_child(sg_node) = (sg_node_ptr)sg_fr;
      UNLOCK(TrNode_lock(sg_node));
      PREG = NEXTOP(PREG, ld);
      PREFETCH_OP(PREG);
      allocate_environment(Y);
      GONext();
    }
    /* subgoal not new */
    UNLOCK(TrNode_lock(sg_node));
    sg_fr = (sg_fr_ptr) TrNode_child(sg_node);
    if (SgFr_completed(sg_fr)) {
      /* subgoal completed */
      ans_node_ptr ans_node = SgFr_answer_trie(sg_fr);
      optyap_message_type2("table_try --> subgoal completed (sg_fr %x)",
                           (unsigned int)sg_fr);
      if (IS_ANSWER_LEAF_NODE(ans_node)) {
        /* yes answer --> procceed */
        PREG = (yamop *)CP;
        PREFETCH_OP(PREG);
        Y = ENV;
        GONext();
      } else if (TrNode_child(ans_node) == NULL) {
        /* no answers --> fail */
        goto fail;
      }
      /* load answers */
      *--Y = 0;  /* vars_arity */
      *--Y = 0;  /* heap_arity */
      PREG = (yamop *) TrNode_child(ans_node);
      PREFETCH_OP(PREG);
      GONext();
    }
    /* subgoal not completed */
    optyap_message_type2("table_try --> subgoal not completed (sg_fr %x)",
                         (unsigned int)sg_fr);
    store_consumer_node(Y, sg_fr);
    /* execute the table_answer_return instruction */
    goto answer_return;
  ENDPBOp();



  Op(table_retry_me, ld)  
    optyap_message_type2("table_retry (sg_fr %x)", (unsigned int)GEN_CP(B)->gcp_sg_fr);
    restore_generator_node(B, PREG->u.ld.s, PREG->u.ld.d);
    Y = (CELL *) PROTECT_FROZEN_B(B);
    set_cut(Y, B->cp_b);
    allocate_environment(Y);
    PREG = NEXTOP(PREG,ld);
    GONext();
  ENDOp();



  Op(table_trust_me, ld)  
    optyap_message_type2("table_trust (sg_fr %x)", (unsigned int)GEN_CP(B)->gcp_sg_fr);
    restore_generator_node(B, PREG->u.ld.s, COMPLETION);
    Y = (CELL *) PROTECT_FROZEN_B(B);
    set_cut(Y, B->cp_b);
    allocate_environment(Y);
    PREG = NEXTOP(PREG,ld);
    GONext();
  ENDOp();



answer_return:
  PBOp(table_answer_return, ld)
    dep_fr_ptr dep_fr;
    sg_fr_ptr sg_fr;
    ans_node_ptr ans_node;

#ifdef YAPOR
    if (B == DepFr_leader_cp(LOCAL_top_dep_fr))
      goto completion;
    if (SCH_shared_cp())
      UNLOCK_OR_FRAME(LOCAL_top_or_fr);
#endif /* YAPOR */
    dep_fr = CONS_CP(B)->ccp_dep_fr;
    sg_fr = DepFr_sg_fr(dep_fr);
    ans_node = DepFr_last_ans(dep_fr);
    if (ans_node == SgFr_last_answer(sg_fr)) {
      /* no new answers */
      optyap_message_type2("table_answer_return --> no new answers (sg_fr %x)",
                           (unsigned int)sg_fr);
#ifdef YAPOR
      if (DepFr_top_chain_cp(dep_fr) == NULL) {
        /* normal backtrack */
        if (SCH_shared_cp()) {
          if (get_work()) {
            goto shared_fail;
	  }
          goto shared_end;
	}
        B = B->cp_b;
        goto fail;
      } else
#endif /* YAPOR */
      {
        /* chain backtrack */
#ifdef YAPOR
        choiceptr top_chain_cp;
#endif /* YAPOR */
        choiceptr chain_cp;
        tr_fr_ptr start_tr, end_tr;
        CELL ref;

        /* find chain choice point to backtrack */
#ifdef YAPOR
        top_chain_cp = DepFr_top_chain_cp(dep_fr);
        chain_cp = MIN_REF(DepFr_leader_cp(LOCAL_top_dep_fr), top_chain_cp);
#else
        chain_cp = DepFr_leader_cp(LOCAL_top_dep_fr);
#endif /* YAPOR */
        dep_fr = DepFr_next(dep_fr);
	while (chain_cp > NORM_CP(DepFr_cons_cp(dep_fr))) {
          if (DepFr_last_ans(dep_fr) != SgFr_last_answer(DepFr_sg_fr(dep_fr))) {
            chain_cp = NORM_CP(DepFr_cons_cp(dep_fr));
#ifdef YAPOR
	    /* update top chain */
            LOCK(DepFr_lock(dep_fr));
            if (DepFr_top_chain_cp(dep_fr) < top_chain_cp)
              DepFr_top_chain_cp(dep_fr) = top_chain_cp;
            UNLOCK(DepFr_lock(dep_fr));
#endif /* YAPOR */
            break;
	  }
          dep_fr = DepFr_next(dep_fr);
	}
        /* restore bindings */
        start_tr = B->cp_tr;
        end_tr = chain_cp->cp_tr;
        /* unbind loop */
        while (start_tr != end_tr) {
          while (start_tr > end_tr) {
  	    ref = (CELL) TrailTerm(--start_tr);
	    if (IsVarTerm(ref)) {
              /* unbind variable */
	      RESET_VARIABLE(ref);
	    } else {
              ref = (CELL) RepPair(ref);
	      if ((ADDR)ref >= TrailBase)
  	        start_tr = (tr_fr_ptr) ref;
	    }
          }
          while (end_tr > start_tr) {
  	    ref = (CELL) TrailTerm(--end_tr);
	    if (! IsVarTerm(ref)) {
              ref = (CELL) RepPair(ref);
	      if ((ADDR)ref >= TrailBase)
  	        end_tr = (tr_fr_ptr) ref;
	    }
          }
        }
        end_tr = chain_cp->cp_tr;
        /* rebind loop */
        while (start_tr != end_tr) {
	  ref = (CELL) TrailTerm(--end_tr);
	  if (IsVarTerm(ref)) {
            /* rebind variable */
	    *((CELL *)ref) = TrailVal(end_tr);
	  } else {
            ref = (CELL) RepPair(ref);
	    if ((ADDR)ref >= TrailBase)
  	      end_tr = (tr_fr_ptr) ref;
	  }
        }
#ifdef YAPOR
        /* update shared nodes */
        if (chain_cp >= LOCAL_top_consumer_cp) {
          or_fr_ptr start_or_fr = LOCAL_top_or_fr;
          or_fr_ptr end_or_fr = chain_cp->cp_or_fr;
          while (start_or_fr != end_or_fr) {
            while (start_or_fr < end_or_fr) {
              LOCK_OR_FRAME(start_or_fr);
              BITMAP_delete(OrFr_members(start_or_fr), worker_id);
              BITMAP_insert(OrFr_hidden_members(start_or_fr), worker_id);
              UNLOCK_OR_FRAME(start_or_fr);
              start_or_fr = OrFr_next_on_branch(start_or_fr);
	    }
            while (start_or_fr > end_or_fr) {
              LOCK_OR_FRAME(end_or_fr);
              BITMAP_insert(OrFr_members(end_or_fr), worker_id);
              BITMAP_delete(OrFr_hidden_members(end_or_fr), worker_id);
              UNLOCK_OR_FRAME(end_or_fr);
              end_or_fr = OrFr_next_on_branch(end_or_fr);
	    }
	  }
          LOCAL_top_cp = chain_cp;
          LOCAL_top_or_fr = LOCAL_top_cp->cp_or_fr;
          LOCAL_load = -DELAYED_RELEASE_LOAD;
	}
#endif /* YAPOR */
        /* update registers TR and B */
        TR = TR_FZ;
        TRAIL_REF(chain_cp->cp_tr);
        B = chain_cp;
        /* backtrack to chain choice point */
	PREG = B->cp_ap;
        PREFETCH_OP(PREG);
	SP = SP0;
	GONext();
      }
    }
    optyap_message_type2("table_answer_return --> new answers (sg_fr %x)",
                         (unsigned int)sg_fr);
    /* update last consumed answer pointer */
    LOCK(DepFr_lock(dep_fr));
    if (ans_node == NULL)
      ans_node = DepFr_last_ans(dep_fr) = SgFr_first_answer(sg_fr);
    else
      ans_node = DepFr_last_ans(dep_fr) = TrNode_child(ans_node);
    UNLOCK(DepFr_lock(dep_fr));
    /* UNLOCK(SgFr_lock(sg_fr)); */
    /* restore consumer choice point */
    H = HBREG = PROTECT_FROZEN_H(B);
    CPREG = B->cp_cp;
    ENV = B->cp_env;
    /* The following procceed invalidates the efect of `set_cut(Y, B->cp_b);' */
    /* load new answer */
    load_answer_trie(ans_node, B);
    /* procceed */
    PREG = (yamop *)CP;
    PREFETCH_OP(PREG);
    Y = ENV;
    GONext();
  ENDPBOp();



  PBOp(table_new_answer, s)
    int arity = PREG->u.s.s;
    gen_cp_ptr gcp = GEN_CP(Y[E_B]);
    sg_fr_ptr sg_fr = gcp->gcp_sg_fr;
    ans_node_ptr ans_node;
    /* possible optimization: when the number of substitution variables 
       is zero, an answer is sufficient to perform an early completion */
    ans_node = answer_search(SgFr_answer_trie(sg_fr), (CELL *)(gcp + 1) + arity);
    LOCK(TrNode_lock(ans_node));
    if (! IS_ANSWER_LEAF_NODE(ans_node)) {
      /* new answer */
      optyap_message_type2("table_new_answer --> new answer (sg_fr %x)",
                           (unsigned int)sg_fr);
      TAG_AS_ANSWER_LEAF_NODE(ans_node);
      UNLOCK(TrNode_lock(ans_node));
      LOCK(SgFr_lock(sg_fr));
      if (SgFr_first_answer(sg_fr) == NULL)
        SgFr_first_answer(sg_fr) = ans_node;
      else 
        TrNode_child(SgFr_last_answer(sg_fr)) = ans_node;
      SgFr_last_answer(sg_fr) = ans_node;
      UNLOCK(SgFr_lock(sg_fr));
      /* deallocate and procceed */
      PREG = CP = (yamop *) Y[E_CP];
      PREFETCH_OP(PREG);
      SREG = Y;
      ENV = Y = (CELL *)Y[E_E];
      GONext();
    }
    optyap_message_type2("table_new_answer --> repeated answer (sg_fr %x)",
                         (unsigned int)sg_fr);
    UNLOCK(TrNode_lock(ans_node));
    goto fail;
  ENDPBOp();



#ifdef YAPOR
completion:
#endif /* YAPOR */
  BOp(table_completion, ld) {
    if (B >= NORM_CP(DepFr_cons_cp(LOCAL_top_dep_fr)) && 
        B != DepFr_leader_cp(LOCAL_top_dep_fr)) {
      /* not leader on that node */
      optyap_message_type2("completion --> not leader (sg_fr %x)",
                           (unsigned int)GEN_CP(B)->gcp_sg_fr);
#ifdef YAPOR
      if (SCH_shared_cp()) {
        UNLOCK_OR_FRAME(LOCAL_top_or_fr);
        if (get_work()) {
          goto shared_fail;
	}
        goto shared_end;
      }
#endif /* YAPOR */
      B = B->cp_b;
      goto fail;
    } else {
      /* leader on that node */
      dep_fr_ptr dep_fr;
      /* check for dependency frames with unconsumed answers */
      dep_fr = LOCAL_top_dep_fr;
      while (B > NORM_CP(DepFr_cons_cp(dep_fr))) {
        if (DepFr_last_ans(dep_fr) != SgFr_last_answer(DepFr_sg_fr(dep_fr))) {    
          /* consumer node with unconsumed answers */
          cons_cp_ptr consumer_cp;
          tr_fr_ptr start_tr, end_tr;
          CELL ref;
          optyap_message_type2("completion --> unconsumed answers (sg_fr %x)",
                               (unsigned int)GEN_CP(B)->gcp_sg_fr);
#ifdef YAPOR
          if (SCH_shared_cp())
            UNLOCK_OR_FRAME(LOCAL_top_or_fr);
#endif /* YAPOR */
          consumer_cp = DepFr_cons_cp(dep_fr);
          start_tr = B->cp_tr;
          end_tr = consumer_cp->ccp_tr;
          /* rebind loop */
          while (start_tr != end_tr) {
	    ref = (CELL) TrailTerm(--end_tr);
	    if (IsVarTerm(ref)) {
              /* rebind variable */
	      *((CELL *)ref) = TrailVal(end_tr);
 	    } else {
              ref = (CELL) RepPair(ref);
	      if ((ADDR)ref >= TrailBase)
  	        end_tr = (tr_fr_ptr) ref;
  	    }
          }
#ifdef YAPOR
          /* update shared nodes */
          if (B > LOCAL_top_consumer_cp) {
            choiceptr top_cp;
            or_fr_ptr or_frame;
            top_cp = NORM_CP(consumer_cp);
            while (top_cp < LOCAL_top_consumer_cp)
              top_cp = top_cp->cp_b;
            or_frame = top_cp->cp_or_fr;
            while (or_frame != LOCAL_top_or_fr) {
              LOCK_OR_FRAME(or_frame);
              BITMAP_insert(OrFr_members(or_frame), worker_id);
              BITMAP_delete(OrFr_hidden_members(or_frame), worker_id);
              UNLOCK_OR_FRAME(or_frame);
              or_frame = OrFr_next_on_branch(or_frame);
            }
            LOCAL_top_cp = top_cp;
            LOCAL_top_or_fr = LOCAL_top_cp->cp_or_fr;
            LOCAL_load = -DELAYED_RELEASE_LOAD;
	  }
          /* update top chain */
          LOCK(DepFr_lock(dep_fr));
          if (DepFr_top_chain_cp(dep_fr) < B)
            DepFr_top_chain_cp(dep_fr) = B;
          UNLOCK(DepFr_lock(dep_fr));
#endif /* YAPOR */
          /* update registers TR and B */
          TR = TR_FZ;
          TRAIL_REF(consumer_cp->ccp_tr);
          B = NORM_CP(consumer_cp);
          goto answer_return;
        }
        dep_fr = DepFr_next(dep_fr);
      }
#ifdef YAPOR
      if (SCH_shared_cp()) {
        /* public completion */
        optyap_message_type2("public completion");
        /* check for workers (hidden or not) */
        if (! BITMAP_empty(OrFr_hidden_members(LOCAL_top_or_fr)) || 
            ! BITMAP_alone(OrFr_members(LOCAL_top_or_fr), worker_id)) {
          optyap_debug_message("W%d: public completion -- suspend completion branch", worker_id);
          UNLOCK_OR_FRAME(LOCAL_top_or_fr);
          /* what happens if there is nothing to suspend? */
          suspend_completion_branch();
	} else {
          UNLOCK_OR_FRAME(LOCAL_top_or_fr);
          /* check for suspension frames with unconsumed answers */
          collect_suspension_frames_with_unconsumed_answers();
          /* check for collected suspension frames */
          if (LOCAL_top_collect_susp_fr != NULL) {
            suspend_completion_branch();
            resume_bottom_collected_suspension_branch();
	  /*
            goto shared_fail ??
	  */
          }
          /* public completion -- complete all */
          public_completion();
	}
        /* backtrack */
        if (get_work()) {
          goto shared_fail;
        }
        goto shared_end;
      } else
#endif /* YAPOR */
      { /* private completion -- complete all */
        private_completion();
        /* backtrack */
        B = B->cp_b;
        goto fail;
      }
    }
  } ENDBOp();
